=begin
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
# Copyright  2010-2011 Fredo6 - Designed and written December 2010 by Fredo6
#
# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is subject to:
#  - the expressed, written consent of the author
#  - the inclusion of the present copyright notice in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   SUClockDialog.rb
# Original Date	:   23 Jan 2011 
# Description	:   Web Dialogs for SUClock
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
=end

module SUClock

T6[:TIT_Project] = "Project"	
T6[:DLG_IdleTime] = "Idle Time"	
T6[:TIP_IdleTime] = "Duration of inactivity to be excluded from tracking"	
T6[:DLG_TargetTime] = "Target Time"	
T6[:TIP_TargetTime] = "Target Time set for Project"	
T6[:DLG_Alarm] = "Alarm at"	
T6[:TIP_Alarm] = "Threshold when clock in displayed in warning mode"	

T6[:DLG_Minutes] = "minutes"	
T6[:LNK_Detach] = "Detach from Project"	
T6[:LNK_AttachNew] = "Attach to New Project"	
T6[:LNK_AttachExist] = "Attach to an existing Project"	
T6[:LNK_MergeWith] = "Merge with another project"	
T6[:LNK_Reset] = "Reset project"	
T6[:LNK_PurgeRecent] = "Purge"	
T6[:TIP_SectionParameters] = "Parameters of the Project attached to the current model"	
T6[:TIP_SectionAttach] = "Determine how the current model is associated with a tracking Project"	
T6[:TIP_SectionStatistics] = "Statistics"	
T6[:TIT_ModelAttachmentProject] = "Tracking of the Model in Project"	
T6[:TIT_RecentProjects] = "Recents Projects"	

T6[:TIP_Detach] = "Do NOT track the model anymore"
T6[:TIP_AttachExist] = "Track the model as part of an Existing Project"
T6[:TIP_AttachNew] = "Track the model as part of a New Project"
T6[:TIP_MergeWith] = "Integrate the data from another project"
T6[:TIP_ClearProject] = "Reset the project to zero"
T6[:TIP_AttachRecent] = "Click on a recent Project to attach the current model to it"
T6[:TIP_PurgeRecent] = "Purge the list of recent project - No file are deleted"
T6[:TIP_SectionStats] = "Various Statistics about where and when time was spent in the Project"

T6[:TIT_ProjectParameters] = "Project Parameters"		
T6[:TIT_ProjectName] = "Project Name:"		
T6[:TIT_ProjectDir] = "Directory:"		
T6[:TIT_TempDir] = "Temporary files in:"		
T6[:TIT_ProjectDate] = "Created on:"		
T6[:TIT_ProjectTime] = "Active time spent:"
T6[:TIT_SessionTime] = "...in Current Session:"
T6[:TIT_Total] = "TOTAL"

T6[:TIT_SelectionMode] = "Selection Mode"	
T6[:TIP_SelectionMode] = "Selection Mode and not using a tool"	
T6[:TIT_SketchupTools] = "Sketchup Tools"	
T6[:TIP_SketchupTools] = "Native Sketchup Tools"	
T6[:TIT_RubyScripts] = "Ruby Scripts"	
T6[:TIP_RubyScripts] = "Ruby Scripts based on Tool mode"	
T6[:TIT_OtherRuby] = "Other Ruby Scripts"	
T6[:TIP_OtherRuby] = "Ruby Scripts not registered"	

T6[:BUT_SUTools] = "SU Tools"	
T6[:BUT_DayMonth] = "Day / Month"	
T6[:BUT_DayWeek] = "Day / Week"	
T6[:BUT_Model] = "SKP Models"	

T6[:HDR_Time] = "Time"
T6[:HDR_MonthDay] = "Month / Day"
T6[:HDR_ToolsRuby] = "SU and Ruby Tools"
T6[:HDR_SKPModels] = "SKP Models"
T6[:HDR_ToolType] = "Tool Type"
T6[:HDR_ToolClass] = "Tool Class"

T6[:MSG_RemoveClockTracking] = "Remove Clock tracking"
T6[:TXT_DateCreaCur] = "Time tracked from %1 to %2"
T6[:MSG_InvalidIdle] = "INVALID Value for Idle time: %1"
T6[:MSG_InvalidTarget] = "INVALID Value for Target time: %1"
T6[:MSG_InvalidAlarm] = "INVALID Value for Alarm threshold: %1"

T6[:MSG_GenerationExport] = "File %2 generated: %1"
T6[:MSG_GenerationExport_Error] = "Error in generation of CSV file %2: %1"
T6[:MSG_GenerationCSV_Open] = "Do you want to open the file?"

T6[:BUT_Export] = "Export"
T6[:TIP_FormatExport] = "Format of the Export"

T6[:ASK_ConfirmProjectReset1] = "Do you want to reset the current project?"
T6[:ASK_ConfirmProjectReset2] = "ALL data and statsitics will be erased"
T6[:ASK_ConfirmProjectReset3] = "This operation is NOT REVERSIBLE"

T6[:ASK_ConfirmMergeWith1] = "Import data into the current project from Project %1?"
T6[:ASK_ConfirmMergeWith2] = "Do you want to reset Project %1 to zero"
T6[:ERR_MergeWithSame] = "ERROR: you can import data from the same current project"
T6[:MSG_TotalTime] = "Total Time = %1"

HTML = Traductor::HTML


#=============================================================
#--------------------------------------------------------------------------------------------------------------------------
# Class TopDialog: main methods
#--------------------------------------------------------------------------------------------------------------------------
#=============================================================
	
class TopDialog	

@@top_dialog = nil

#Close the top dialog
def TopDialog.close_dialog
	@@top_dialog.close_dialog if @@top_dialog
end

#Update the total and session times if the dialog box is displayed
def TopDialog.update_time
	@@top_dialog.update_time_displayed if @@top_dialog
end

#Invoke the Parameter dialog box
def TopDialog.display(tracker, project=nil)
	model = Sketchup.active_model
	return unless model
	path = (model.path) ? model.path : model.guid
	unique_key = "SUClockTop" + path
	#@@top_dialog = TopDialog.new(unique_key, tracker, project) unless Traductor::Wdlg.check_instance_displayed(unique_key)
	TopDialog.new(unique_key, tracker, project) unless Traductor::Wdlg.check_instance_displayed(unique_key)
end

#Calculate the dialog box
def initialize(unique_key, tracker, project=nil)
	#Initialization
	@tracker = tracker
	@project = project
	@notify_close_proc = self.method "on_close_stats_dialog"
	@hsh_stats_dialogs = {}
	@vtype_idle = Traductor::VTYPE.new SUClock.idle_limits
	@vtype_alarm = Traductor::VTYPE.new SUClock.alarm_limits
	
	@title = T6[:TIT_Project]
	if @project
		@title += ' ' + @project.prjname
		@prjname = project.prjname
		@prjpath = project.prjpath
		@prjdir = File.dirname @prjpath
	else
		@prjname = ""
		@prjpath = ""
	end	

	#Computing the HTML
	html = format_html_top
	
	#Creating the dialog box
	@wdlg_key = 'SUClock_DlgParameter'
	@wdlg = Traductor::Wdlg.new @title, @wdlg_key, false
	@wdlg.set_unique_key unique_key
	@wdlg.set_html html
	h = (@project) ? 550 : 250
	@wdlg.set_size 700, h
	@wdlg.set_background_color 'AliceBlue'
	@wdlg.set_callback self.method('callback_dialog_top') 
	@wdlg.set_on_close { on_close } 
	@wdlg.show
	
end

def refresh_window
	@wdlg.set_html format_html_top if @wdlg
end

#Utility to format time
def format_time(t)
	h = (t / 3600).floor
	m = ((t - h * 3600) / 60).floor
	s = t - 3600 * h - 60 * m
	"#{h}:" + sprintf('%02d', m) + ':' + sprintf('%02d', s.floor)
end

#Build the HTML for TOP Dialog
def format_html_top
	
	#Creating the HTML stream	
	html = Traductor::HTML.new
	
	#Special_scripts
	html.script_add special_script
	
	#style used in the dialog box
	html.create_style 'Button', nil, 'K: black', 'F-SZ: 10'
	html.create_style 'ButtonStats', nil, 'K: black', 'BG: lightyellow', 'F-SZ: 10'
	html.create_style 'Label', nil, 'B', 'K: black', 'F-SZ: 11'
	html.create_style 'LabelBig', nil, 'B', 'K: black', 'F-SZ: 12'
	html.create_style 'LabelSmall', nil, 'B', 'K: black', 'F-SZ: 10'
	html.create_style 'Input', nil, 'B', 'K: navy', 'F-SZ: 11', 'text-align: center'
	html.create_style 'InputSmall', nil, 'B', 'K: navy', 'F-SZ: 10', 'text-align: center'
	html.create_style 'Title', nil, 'B', 'K: navy', 'F-SZ: 12'
	html.create_style 'TitleBig', nil, 'B', 'K: red', 'F-SZ: 12'
	html.create_style 'TitleBigBlue', nil, 'B', 'K: blue', 'F-SZ: 12'
	html.create_style 'TitleSmall', nil, 'B', 'K: black', 'F-SZ: 11'
	html.create_style 'FieldDir', nil, 'B', 'K: blue', 'F-SZ: 10'
	html.create_style 'FieldTmp', nil, 'B', 'I', 'K: darkgrey', 'F-SZ: 10'
	html.create_style 'FieldCreated', nil, 'B', 'K: green', 'F-SZ: 11'
	html.create_style 'Link', nil, 'B', 'I', 'K: black', 'F-SZ: 11', 'margin-bottom: 2px'
	html.create_style 'LinkRed', 'Link', 'K: red'
	html.create_style 'LinkGreen', 'Link', 'K: green'
	html.create_style 'LinkBlue', 'Link', 'K: navy'
	html.create_style 'LinkPurple', 'Link', 'K: purple'
	html.create_style 'LinkBlack', 'Link', 'K: black'
	html.create_style 'LinkRecentTitle', 'Link', 'BG: gray', 'K: lightgrey'
	html.create_style 'LinkRecent', 'Link', 'F-SZ: 10', 'K: black'
	html.create_style 'LinkPurge', 'Link', 'F-SZ: 9', 'K: navy'
	html.create_style 'Header', nil, 'B', 'I', 'K: white', 'F-SZ: 12', 'text-align: center', 'margin-bottom: 10px'
	html.create_style 'Section', nil, 'K: white ; B ; F-SZ: 13', 'text-align: center', 'border-style: solid', 
	                  'BD-SZ: 2', 'BD-COL: LightGrey', 'padding-top: 3px', 'padding-bottom: 3px'
	html.create_style 'SectionProj', 'Section', 'BG: navy'
	html.create_style 'SectionAttach', 'Section', 'BG: green'
	html.create_style 'SectionStats', 'Section', 'BG: darkorange'
	
	space = '&nbsp'
	space2 = space * 2
	
	#Creating the main table
	html.body_add "<table width='99%' cellpadding='1px'>"
		
	#Section for the parameters
	if @project
		header = HTML.format_span T6[:TIT_ProjectParameters], "", 'Header'
		label_name = HTML.format_span T6[:TIT_ProjectName], "", 'LabelBig'
		field_name = HTML.format_span @prjname, "", 'TitleBigBlue'	
		label_dir = HTML.format_span T6[:TIT_ProjectDir], "", 'LabelSmall'
		field_dir = HTML.format_span @prjdir, "", 'FieldDir'
		label_tmpdir = HTML.format_span T6[:TIT_TempDir], "", 'LabelSmall'
		field_tmpdir = HTML.format_span Project.get_tmpdir, "", 'FieldTmp'
		crea_date = Time.at(@project.creation_date).strftime "%d-%b-%y %H:%M"
		label_date = HTML.format_span T6[:TIT_ProjectDate], "", 'LabelSmall'
		field_date = HTML.format_span crea_date, "", 'FieldCreated'
		
		label_time = HTML.format_span T6[:TIT_ProjectTime], "", 'LabelBig'
		field_time = HTML.format_span format_time(@project.total_time), "ID_TOTAL_TIME", 'TitleBig'
		label_sstime = HTML.format_span T6[:TIT_SessionTime], "", 'LabelSmall'
		field_sstime = HTML.format_span format_time(@project.session_time), "ID_SESSION_TIME", 'TitleSmall'
		
		tip = T6[:TIP_IdleTime] + "\n#{@vtype_idle.as_text}"
		tidle = "#{@project.idle.round / 60}"
		label_idle = HTML.format_span T6[:DLG_IdleTime], "", 'Label', nil, tip	
		field_idle = HTML.format_input(tidle, "2", "IDLE_TIME", 'Input', nil, tip)
		field_idle += space2 + HTML.format_span(T6[:DLG_Minutes], "", 'Label', nil, tip)
		
		tip = T6[:TIP_TargetTime]
		ttarget = format_hour_minute @project.target_time
		label = "#{T6[:DLG_TargetTime]} (hh:mm)"
		label_target = HTML.format_span label, "", 'LabelSmall', nil, tip	
		field_target = HTML.format_input(ttarget, "10", "TARGET_TIME", 'InputSmall', nil, tip)
		
		tip = T6[:TIP_Alarm] + "\n#{@vtype_alarm.as_text}"
		talarm = "#{(@project.alarm_threshold * 100).round}"
		label_alarm = HTML.format_span T6[:DLG_Alarm], "", 'LabelSmall', nil, tip	
		field_alarm = HTML.format_input(talarm, "2", "ALARM_THRESHOLD", 'InputSmall', nil, tip)
		field_alarm += space2 + HTML.format_span("%", "", 'LabelSmall', nil, tip)
		field_target += space2 + space2 + label_alarm + space2 + field_alarm
		
		txt = "<tr class='SectionProj'><td align='center' title='#{T6[:TIP_SectionParameters]}'>#{header}</td></tr>"
		txt += "<tr><td><table>"
		lst = [[label_name, field_name], [label_time, field_time], [label_sstime, field_sstime], 
		       [label_idle, field_idle], [label_target, field_target],
			   [label_dir, field_dir], [label_tmpdir, field_tmpdir], [label_date, field_date]]
		lst.each do |a| 
			txt += "<tr><td width='35%' valign='bottom'>#{a[0]}</td><td valign='bottom'>#{a[1]}</td></tr>"
		end	
		txt += "</table></td></tr>"	
				
		html.body_add txt
	end

	#Project Attachment
	if @project || Tracker.get_model_prjpath
		hdetach = HTML.format_textlink T6[:LNK_Detach], "Detach", "LinkRed", nil, T6[:TIP_Detach]
	else
		hdetach = nil
	end	
	hnew = HTML.format_textlink T6[:LNK_AttachNew], "New", "LinkGreen", nil, T6[:TIP_AttachNew]
	hother = HTML.format_textlink T6[:LNK_AttachExist], "Existing", "LinkBlue", nil, T6[:TIP_AttachExist]
	hmerge = HTML.format_textlink T6[:LNK_MergeWith], "MergeWith", "LinkPurple", nil, T6[:TIP_MergeWith]
	hreset = HTML.format_textlink T6[:LNK_Reset], "Reset", "LinkBlack", nil, T6[:TIP_ResetProject]
	header = HTML.format_span T6[:TIT_ModelAttachmentProject], "", 'Header', nil, ''

	txt = "<tr class='SectionAttach'><td align='center' title='#{T6[:TIP_SectionAttach]}'>#{header}</td></tr>"
	txt += "<tr><td>#{HTML.format_table_equal_column(3, nil, [hdetach, hnew, hother])}</td></tr>"
	if @project || Tracker.get_model_prjpath
		txt += "<tr><td>#{HTML.format_table_equal_column(3, nil, [hmerge, hreset, nil])}</td></tr>"
	end
	html.body_add txt
		
	#Recent projects section
	@lsmru = Project.mru_list @project
	unless @lsmru.empty?
		nbcol = 3
		nbmax = 12
		lst = []
		@lsmru[0..nbmax-1].each_with_index do |a, i|
			lst.push((a) ? HTML.format_textlink(a[0], "MRU-#{i}", "LinkRecent", nil, a[1]) : nil)
		end			
		txt = "<tr><td>"
		txt += HTML.format_span(' ' + T6[:TIT_RecentProjects] + ' ', "", 'LinkRecentTitle', nil, T6[:TIP_AttachRecent])	
		txt += space2 + HTML.format_textlink(T6[:LNK_PurgeRecent], "PurgeRecent", "LinkPurge", nil, T6[:TIP_PurgeRecent])
		txt += "</td></tr><tr><td>#{HTML.format_table_equal_column(nbcol, nil, lst)}</td></tr>"
		html.body_add txt
	end

	#Statistics
	if @project
		bday = HTML.format_button(T6[:BUT_DayMonth], id="ButtonStats-DM", 'ButtonStats', nil)
		btool = HTML.format_button(T6[:BUT_SUTools], id="ButtonStats-T", 'ButtonStats', nil)
		bfile = HTML.format_button(T6[:BUT_Model], id="ButtonStats-F", 'ButtonStats', nil)
		
		html.body_add "<tr class='SectionStats'>"
		html.body_add "<td align='center' title='#{T6[:TIP_SectionStats]}'>"
		html.body_add HTML.format_span(T6[:TIP_SectionStatistics], "", 'Header')	
		html.body_add "</td></tr>"
		html.body_add "<tr><td>"	
		html.body_add bday, '&nbsp&nbsp', btool, '&nbsp&nbsp', bfile
		html.body_add "</td></tr>"
	end

	#Closing the table
	html.body_add "</table>"
	
	#Creating the DONE button
	butdone = HTML.format_button T6[:T_BUTTON_Done], id="ButtonDone", 'Button', nil
	html.body_add "<table width='99%' cellpadding='0px'>"
	html.body_add "<tr><td align='right'>", butdone, "</td></tr></table>"
	
	#Returning the HTML object
	html	
end

#Encode a format <Hour>h<minute>
def format_hour_minute(time)
	return "" if time <= 0
	h = time / 3600
	m = (time - h * 3600) / 60
	d = (m < 10) ? "0" : ""
	"#{h}h#{d}#{m}"
end

#Call back for Top Dialog
def callback_dialog_top(event, type, id, svalue)
	case event
	
	#Initialistaion
	when /wonload/i
		@@top_dialog = self
	
	#Command buttons
	when /onchange/i
		case id
		when 'IDLE_TIME'
			return change_idle_time(svalue)
		when 'TARGET_TIME'
			return change_target_time(svalue)
		when 'ALARM_THRESHOLD'
			return change_alarm_threshold(svalue)
		end	

	when /onclick/i
		case id
		when 'ButtonDone'
			@wdlg.close
		when 'Detach'
			@wdlg.close if process_detach_model
		when 'New'
			@wdlg.close if process_attach_model nil, true
		when 'Existing'
			@wdlg.close if process_attach_model nil, false
		when 'Reset'
			process_reset
		when 'MergeWith'
			process_merge_with
		when 'PurgeRecent'
			process_purge_recent
		when /MRU\-(\d+)/
			@wdlg.close if process_attach_model @lsmru[$1.to_i][-1], false
		when /ButtonStats\-(.+)/
			call_stats_dialog $1	
		end
		
	when /onKeyUp/i	#Escape and Return key
		@wdlg.close if svalue =~ /\A27\*/ #|| svalue =~ /\A13\*/
		
	end
end

#Update the total and session time
def update_time_displayed
	return unless @project
	stotal_time = format_time(@project.total_time)
	ssession_time = format_time(@project.session_time)
	sidle = (@project.idle / 60).round
	@wdlg.execute_script "suclock_update_time('#{stotal_time}', '#{ssession_time}', '#{sidle}')"
	return
	@wdlg.jscript_set_prop "ID_TOTAL_TIME", "innerHTML", format_time(@project.total_time)
	@wdlg.jscript_set_prop "ID_SESSION_TIME", "innerHTML", format_time(@project.session_time)
	@wdlg.jscript_set_prop "IDLE_TIME", "value", "#{(@project.idle / 60).round}"
end

#Special javascript to update fields in the main web dialog
def special_script
	text = %Q~

function suclock_update_time(stotal_time, ssession_time, sidle) {
	obj = document.getElementById ('ID_TOTAL_TIME') ;
	obj.innerHTML = stotal_time ;
	obj = document.getElementById ('ID_SESSION_TIME') ;
	obj.innerHTML = ssession_time ;
	var obj = document.getElementById ('IDLE_TIME') ;
	if (obj.value != sidle) obj.value = sidle ;
}	
~
	text
end

#Manage a change of idle time
def change_idle_time(sval)
	old_idle = (@project.idle / 60).round
	tminutes = @vtype_idle.validate sval
	unless tminutes
		UI.messagebox T6[:MSG_InvalidIdle, sval]
		return sval
	end	
	new_idle = tminutes * 60
	@project.change_idle_time new_idle if old_idle != new_idle
	"#{tminutes}"
end

#Manage a change of target time
def change_target_time(sval)
	sval = (sval) ? sval.strip : "0"
	h = nil
	if sval =~ /(\d*):(\d*)/ || sval =~ /(\d*)h(\d*)/
		h = ($1 == "") ? 0 : $1.to_i
		m = ($2 == "") ? 0 : $2.to_i
		m = nil if m > 59
	elsif sval =~ /\d+/
		h = ($1 == "") ? 0 : $&.to_i
		m = 0
	end	
	unless h
		UI.messagebox T6[:MSG_InvalidTarget, sval]
		return sval
	end			
	new_target = h * 3600 + m * 60
	@project.change_target_time new_target
	format_hour_minute new_target
end

#Manage a change of alram threshold
def change_alarm_threshold(sval)
	old_alarm = @project.alarm_threshold
	t = nil
	if sval == nil || sval.strip == ""
		t = MYDEFPARAM[:DEFAULT_AlarmThreshold]
	elsif sval =~ /(\d*)(\.|,)(\d*)/ && sval.to_f > 0.0
		t = @vtype_alarm.validate "#{($&.to_f * 100).round}"
	elsif sval =~ /(\d+)\%*/
		t = @vtype_alarm.validate $1
	end	
	unless t
		UI.messagebox T6[:MSG_InvalidAlarm, sval]
		return sval
	end	
	@project.change_alarm_threshold t
	"#{t}"
end

#Open a dialog box for Statistics
def call_stats_dialog type
	stats_wdlg = StatsDialog.display type, @project, @notify_close_proc	
	@hsh_stats_dialogs[type] = stats_wdlg
end

#Force a close of the dialog boxes
def close_dialog
	@wdlg.close
end
	
#Notification when the top dialog box closes	
def on_close()
	@hsh_stats_dialogs.each { |key, val| val.close_dialog }
	@@top_dialog = nil
end

#Notification when a Stats dialog box closes
def on_close_stats_dialog(wd)
	@hsh_stats_dialogs.delete_if { |key, val| val == wd }
end

#proceed with the detachment of the model from tracking
def process_detach_model
	status = UI.messagebox T6[:MSG_RemoveClockTracking], MB_YESNO
	if status == 6
		@tracker.notify_detachment(@project)
		return true
	end
	false	
end

#Process with the attachment of a model to a file, which is asked
def process_attach_model(prjpath, creation=false)
	if prjpath
		if FileTest.exist?(prjpath) && !Project.file_is_valid?(prjpath)
			UI.messagebox T6[:MSG_InvalidFile, prjpath]
			return false
		end	
	else
		prjpath = Project.ask_path creation
	end
	
	if prjpath
		@tracker.register_attachment prjpath
		@tracker.model_changing Sketchup.active_model, "attach", false
		return true
	end	
	false
end

#Process the reset request
def process_reset
	txt = T6[:ASK_ConfirmProjectReset1] + "\n\n" + T6[:ASK_ConfirmProjectReset2] + "\n\n" + T6[:ASK_ConfirmProjectReset3]
	return unless UI.messagebox(txt, MB_YESNO) == 6
	@project.reset_to_zero
	refresh_window
end

#Process the Merge with request
def process_merge_with
	#asking for the other project
	opath = Project.ask_path
	return unless opath
	if (opath == @prjpath)
		UI.messagebox T6[:ERR_MergeWithSame]
		return
	end	
	other_prjname = Project.name_from_path opath
	s = "<#{other_prjname}>"
	
	#Importation of data
	tt = Project.get_total_time opath
	txt = T6[:ASK_ConfirmMergeWith1, s] + "\n" + T6[:MSG_TotalTime, format_time(tt)]
	return unless UI.messagebox(txt, MB_YESNO) == 6
	@project.stats_import opath
	refresh_window
	
	#Reset other project to zero
	txt = T6[:ASK_ConfirmMergeWith2, s]
	return unless UI.messagebox(txt, MB_YESNO) == 6
	Project.reset_other_project opath
end

#Process the purge the recent list
def process_purge_recent
	Project.mru_purge
	refresh_window
end

end	#class TopDialog

#=============================================================
#--------------------------------------------------------------------------------------------------------------------------
# Class StatsDialog: main methods
#--------------------------------------------------------------------------------------------------------------------------
#=============================================================

class StatsDialog

@@export_type = nil

#Invoke the Parameter dialog box
def StatsDialog.display(type, project=nil, notify_close_proc=nil)
	key = 'SUClock' + type.to_s + project.prjpath
	StatsDialog.new(key, type, project, notify_close_proc) unless Traductor::Wdlg.check_instance_displayed(key)
end

#Calculate the dialog box
def initialize(unique_key, type, project=nil, notify_close_proc=nil)
	#Initialization
	@notify_close_proc = notify_close_proc
	@project = project
	@type = type
	@@export_type = MYDEFPARAM[:DEFAULT_Flag_Export] unless @@export_type
	
	#Title
	case type
	when 'DM'
		@title = T6[:BUT_DayMonth]
	when 'T'
		@title = T6[:BUT_SUTools]	
	when 'F'
		@title = T6[:BUT_Model]
	else
		return
	end	
		
	#Getting the data
	@project.stats_save if @project
	@ltable = prepare_data @type
	
	#Creating the dialog box
	@wdlg_key = 'SUClock_Stats' + type.to_s
	@wid_col1 = (@type == 'F') ? 250 : 170
	@wid_colT = 100
	@wid_colP = 80
	
	@wdlg = create_dialog 
end	

#Create the dialog box
def create_dialog
	wdlg = Traductor::Wdlg.new @title, @wdlg_key, false
	wdlg.set_unique_key @unique_key
	wid = @wid_col1 + @wid_colT + 2 * @wid_colP + 100
	wdlg.set_size wid, 600
	wdlg.set_background_color 'lightyellow'
	wdlg.set_callback self.method('statsdialog_callback') 
	wdlg.set_on_close { on_close() }
	html = format_html_stats @type, wdlg
	wdlg.set_html html
	wdlg.show
	wdlg
end

def on_close
	@notify_close_proc.call(self) if @notify_close_proc
end

#Close the dialog box
def close_dialog
	@wdlg.close
end

#Build the HTML for Statistics Dialog
def format_html_stats(type, wdlg)
	
	#Creating the HTML stream	
	html = Traductor::HTML.new
	
	#style used in the dialog box
	bgcolor = 'BG: aliceblue'
	
	html.create_style 'Title', nil, 'B', 'K: navy', 'F-SZ: 18', 'text-align: center'
	html.create_style 'SubTitle', nil, 'B', 'I', 'K: green', 'F-SZ: 14', 'text-align: center'
	html.create_style 'Col1', nil, 'B', 'K: black'
	html.create_style 'ColT', nil, 'B', 'K: blue', 'text-align: right'
	html.create_style 'ColP', nil, 'B', 'K: red', 'text-align: right'
	html.create_style 'ColPP', nil, 'B', 'K: green', 'text-align: right'
	html.create_style 'Header1', 'Col1', 'F-SZ: 13', bgcolor
	html.create_style 'HeaderT', 'ColT', 'F-SZ: 13', bgcolor
	html.create_style 'HeaderP', 'ColP', 'F-SZ: 10', bgcolor
	html.create_style 'HeaderPP', 'ColPP', 'F-SZ: 11', bgcolor
	html.create_style 'Level0', nil, 'B', 'F-SZ: 13', 'BG: lightgrey'
	html.create_style 'LevelY', nil, 'B', 'F-SZ: 13', 'BG: oldlace'
	html.create_style 'Level1', nil, 'B', 'F-SZ: 12'
	html.create_style 'Level2', nil, 'I', 'F-SZ: 10'
	html.create_style 'Date', nil, 'B', 'F-SZ: 11', 'K: gray'
	
	html.create_style 'XButton', nil, 'I', 'F-SZ: 10', 'Border: 1px solid red'

	#Creating the main table
	@xtable = Traductor::HTML_Xtable.new "XT0", html, wdlg
	hoptions = option_xtable type, html
	txt_table = @xtable.format_table(@ltable, hoptions)
	
	#Creating the title
	text = ""
	text += "<div cellspacing='0px' cellpadding='0px' class='Title'>#{@project.prjname}</div>"
	text += "<div class='SubTitle'>#{@title}</div>"
	text += "<div style='height: 6px'>&nbsp</div>"
	html.body_add text
	
	#Date creation and current
	crea_date = Time.at(@project.creation_date).strftime "%d-%b-%y %H:%M"
	now_date = Time.at(@project.time_store_stats).strftime "%d-%b-%y %H:%M"
	text = "<div><table width='100%' cellspacing='0' cellpadding='0'><tr>"
	text += "<td align='left' valign='bottom'>#{@xtable.html_expand_buttons}</td>"
	text += "<td align='right' class='Date'>#{T6[:TXT_DateCreaCur, crea_date, now_date]}</td>"
	text += "</tr></table></div>"
	html.body_add text
	
	#Inserting the main table
	html.body_add "<div>", txt_table, "</div>"
	
	#Creating the DONE button
	butdone = HTML.format_button T6[:T_BUTTON_Done], "ButtonDone", 'Button', nil
	butexport = HTML.format_button T6[:BUT_Export], "ButtonExport", 'Button', nil
	combexport = HTML.format_combobox @@export_type, T6[SUClock::OPT_Export], "ID_TYPE_EXPORT", classname="Button", nil, T6[:TIP_FormatExport]
	butprint = HTML.format_button T6[:T_BUTTON_Print], id="ButtonPrint", 'Button', nil
	html.body_add "<table class='T_NOPRINT_Style' width='99%' cellpadding='6px'><tr>"
	html.body_add "<td width='50%' align='left'>", butexport + "&nbsp;" + combexport, "</td>"
	html.body_add "<td width='25%' align='left'>", butprint, "</td>"
	html.body_add "<td align='right'>", butdone, "</td>"
	html.body_add "</tr></table>"
	
	#Returning the HTML object
	html	
end

#Call back for Statistics Dialog
def statsdialog_callback(event, type, id, svalue)
	case event
	
	#Command buttons
	when /onclick/i
		case id
		when 'ButtonDone'
			@wdlg.close
		when 'ButtonPrint'
			@wdlg.print
		when 'ButtonExport'
			export_stats
		end
	when /onchange/i
		case id
		when "ID_TYPE_EXPORT"
			@@export_type = svalue
		end
	
	when /onKeyUp/i	#Escape and Return key
		@wdlg.close if svalue =~ /\A27\*/ || svalue =~ /\A13\*/
		
	end
end

def prepare_data(type)
	case type
	when 'T'
		prepare_data_tools
	when 'F'
		prepare_data_models
	when 'DM'
		prepare_data_by_month
	else
		nil
	end	
end

#Prepare the data for Tools statistics
def prepare_data_tools
	hsh = @project.stats_get_list 'T'
	ts_select = 0 
	lst_su = [] 
	ts_su = 0
	lst_ruby = [] 
	ts_ruby = 0
	ts_other_ruby = 0
	ltable = []
	
	#Splitting in categories
	hsh.each do |key, val|
		case key
		when /\ASelection\Z/
			ts_select = val
		when /Ruby:\s(.+)/
			lst_ruby.push [$1, val]
			ts_ruby += val
		when /Ruby/
			ts_other_ruby += val
		else
			lst_su.push [key, val]
			ts_su += val
		end
	end
	ts_ruby += ts_other_ruby
	lst_ruby.sort! { |a, b| b[1] <=> a[1] }
	lst_su.sort! { |a, b| b[1] <=> a[1] }
	ts_total = ts_select + ts_su + ts_ruby
	
	#Assembling the hierarchical list
	#       Level < 0  --> shrinked - image is Plus
	#       Level > 0 --> expanded - image is Minus
	desc_selection = [T6[:TIT_SelectionMode], T6[:TIP_SelectionMode]]
	desc_su = [T6[:TIT_SketchupTools], T6[:TIP_SketchupTools]]
	desc_ruby = [T6[:TIT_RubyScripts], T6[:TIP_RubyScripts]]
	desc_other_ruby = [T6[:TIT_OtherRuby], T6[:TIP_OtherRuby]]
	
	ltable.push [1, desc_selection, nil, format_time(ts_select), format_percent(ts_select / ts_total), ts_select] if ts_select > 0
	ltable.push [-1, desc_su, nil, format_time(ts_su), format_percent(ts_su / ts_total), ts_su] if ts_su > 0
	lst_su.each do |a| 
			t = a[1]
			ltable.push [2, [a[0]], format_percent(t / ts_su), format_time(t), format_percent(t / ts_total), t] 
	end	
	if ts_ruby > 0
		ltable.push [-1, desc_ruby, nil, format_time(ts_ruby), format_percent(ts_ruby / ts_total), ts_ruby]
		lst_ruby.each do |a| 
			t = a[1]
			ltable.push [2, [a[0]], format_percent(t / ts_ruby), format_time(t), format_percent(t / ts_total), t] 
		end	
		if ts_other_ruby > 0
			t = ts_other_ruby
			ltable.push [2, desc_other_ruby, format_percent(t / ts_ruby), format_time(t), format_percent(t / ts_total), t] 
		end	
	end	
	ltable.push [0, [T6[:TIT_Total]], nil, format_time(ts_total), nil, ts_total]
	ltable
end

#Prepare the data for Model statistics
def prepare_data_models
	hsh = @project.stats_get_list 'F'
	ltable = []
	ts_total = 0 
	hsh.each { |key, val| ts_total += val }
	
	#Splitting in categories
	hsh.each do |key, val|
		if key == "nil" || key.empty?
			fname = 'Untitled'
			fdir = 'Unknown'
		else
			fname = File.basename key, '.skp'
			fdir = File.dirname key
		end	
		ltable.push [1, [fname, fdir], nil, format_time(val), format_percent(val / ts_total), val, fdir]
	end
	ltable.sort! { |a, b| b[3] <=> a[3] }
	ltable.push [0, [T6[:TIT_Total]], nil, format_time(ts_total), nil, ts_total]
	ltable	
end

#Prepare the data for Tools statistics
def prepare_data_by_month
	hsh = @project.stats_get_list 'D'
	ltable = []
	hsh_val = Hash.new 0
	hsh_year = Hash.new 0
	ts_total = 0
	
	#Splitting in months
	lst = []
	hsh.each do |key, val|
		next unless key =~ /(\d\d\d\d)\/(\d\d)\/(\d\d)/
		year = $1
		month = $2
		day = $3
		my = year + month
		lst.push [my, key, year, month, day, val]
		hsh_val[my] += val
		hsh_year[year] += val
		ts_total += val
	end
	lst.sort! { |a, b| b[1] <=> a[1] }
	now = Time.now
	current_year = now.year.to_s
	current_month = current_year + sprintf("%02d", now.month)
	
	#Assembling the table
	myprev = nil
	yearprev = nil
	mtime = nil
	lst.each do |a|
		my, myd, year, month, day, t = a
		gm = Time.gm year, month, day
		unless yearprev && year == yearprev
			ytime = hsh_year[year]
			exp = (year == current_year) ? 1 : -1
			ltable.push [exp, [year], nil, format_time(ytime), format_percent(ytime / ts_total), ytime]
			yearprev = year
		end
		unless myprev && my == myprev
			mtime = hsh_val[my]
			mytx = month + ' - ' + year
			mytx = gm.strftime "%b %Y"
			exp = (my == current_month) ? 2 : -2
			ltable.push [exp, [mytx], nil, format_time(mtime), format_percent(mtime / ts_total), mtime]
		end	
		pct = t / mtime
		pctt = t / ts_total
		dx = gm.strftime "%a %d %b"
		dxx = gm.strftime "%d-%b-%Y"
		ltable.push [-3, [dx], format_percent(pct), format_time(t), format_percent(pctt), t, dxx]
		myprev = my
	end
	ltable.push [0, [T6[:TIT_Total]], nil, format_time(ts_total), nil, ts_total]
	ltable	
end

#Utility to format time
def format_time(t)
	h = (t / 3600).floor
	m = ((t - h * 3600) / 60).floor
	s = t - 3600 * h - 60 * m
	"#{h}:" + sprintf('%02d', m) + ':' + sprintf('%02d', s.floor)
end

#Utility to format percent
def format_percent(p, ndec=1)
	sprintf("%.1f%", 100 * p)
end

#Options for  the Xtable
def option_xtable(type, html)
	#Specification for columns and headers
	case type
	when 'DM'
		text = T6[:HDR_MonthDay]
	when 'T'
		text = T6[:HDR_ToolsRuby]
	when 'F'
		text = T6[:HDR_SKPModels]
	end	
	txtime = T6[:HDR_Time]
	
	h1 = { :content => text, :style => "Header1" }
	h2 = { :content => ((type == 'F') ? "" : "%%"), :style => "HeaderPP" }
	h3 = { :content => txtime, :style => "HeaderT" }
	h4 = { :content => "%", :style => "HeaderP" }
	c1 = { :style => "Col1", :width => @wid_col1 }
	c2 = { :style => "ColPP", :width => @wid_colP }
	c3 = { :style => "ColT", :width => @wid_colT }
	c4 = { :style => "ColP", :width => @wid_colP }
	lv0 = { :style => "Level0", :css_style => "border-top: 2px solid black; border-bottom: 2px solid black" }
	lvy = { :style => "LevelY", :css_style => "border-top: 1px solid gray; " }
	lv1 = { :style => "Level1", :css_style => "border-top: 1px dashed gray;" }
	lv2 = { :style => "Level2" }
	
	levels = (type =~ /D/) ? [lv0, lvy, lv1, lv2] : [lv0, lv1, lv2]
	
	#Returning the Options
	hoptions = { :columns => [c1, c2, c3, c4], :headers => [h1, h2, h3, h4], :levels => levels }
end

#------------------------------------------------------------------------------------------
# Export Generatiion
#------------------------------------------------------------------------------------------

#Export the statistics
def export_stats
	case @@export_type
	when 'HTML'
		export_html
	else
		export_tabbed
	end
end

#Generate a CSV file for statistics
def export_tabbed
	#Type of export
	case @@export_type
	when "TAB"
		sepa = "\t"
		ext_file = "txt"
		file_type = T6[:OPT_Export_Tabbed]
	else
		sepa = ","
		ext_file = "csv"
		file_type = T6[:OPT_Export_CSV]
	end
	
	#Building the file name
	trailers = []
	if @type == 'T'
		ext_type = "Tools"
		headers = [T6[:HDR_ToolType], T6[:HDR_ToolClass]]
	elsif @type == 'F'
		ext_type = "Models"
		headers = [T6[:HDR_SKPModels]]
		trailers = [T6[:T_TXT_Directory]]
	elsif @type =~ /\ADM/
		ext_type = "Dates"
		headers = [T6[:T_TXT_Year], T6[:T_TXT_Month], T6[:T_TXT_Day]]
	else
		return
	end
	headers += ["%%", T6[:HDR_Time], "%", T6[:T_TXT_Second]] + trailers
	
	#Building the file name
	cur_date = Time.now.strftime "%d%b%y-%Hh%M"
	fdir = File.dirname @project.prjpath
	fbase = "#{@project.prjname} #{cur_date} #{ext_type}.#{ext_file}" 
	
	#Asking for the file
	path = UI.savepanel T6[:BUT_Export], fdir, fbase
	return unless path
	path = path.gsub(/\\/, '/')
	
	#Prepare the table
	level_max = 0
	@ltable.each { |a| lev = a[0].abs ; level_max = lev if lev > level_max }
	ltable = []
	for i in 0..@ltable.length-1
		level, name = ll = @ltable[i]
		level = (level == 0) ? 0 : level.abs - 1
		a = []
		a[level] = name[0]
		a[level_max..-1] = ll[2..-1]
		ltable[i] = a
	end	
		
	#Generating the file
	begin
		File.open(path, 'w') do |f| 
			f.puts headers.join(sepa)
			ltable.each do |a|
				f.puts a.join(sepa)
			end	
		end
		status = UI.messagebox T6[:MSG_GenerationExport, path, file_type] + "\n\n" + T6[:MSG_GenerationCSV_Open], MB_YESNO
		Traductor.openURL path if status == 6
	rescue
		UI.messagebox T6[:MSG_GenerationExport_Error, path, file_type]
	end
end

#Export as HTML
def export_html
	UI.messagebox "Export HTML not yet implemented"
end

end	#class StatsDialog

end	#End Module SUClock
